package org.moeaframework.core.fitness;


import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import org.moeaframework.core.FitnessEvaluator;

import org.moeaframework.core.Population;
//import org.moeaframework.core.Settings;
import org.moeaframework.core.Solution;

//Euclidean distance is calculated 


public class DistanceFitnessEvaluator implements FitnessEvaluator{
	
	
	/**
	 * Constructs a new crowding distance fitness evaluator.
	 */
	public DistanceFitnessEvaluator() {
		super();
	}

//	@Override
//	public void evaluate(Population population) {
//		
//		int popsize = population.size();
//		int[] NoDup = new int[popsize];
//		int length = population.get(0).getNumberOfObjectives();
//		
////		double[][] minmax= new double[length][2];
//		
////		for (int f = 0; f < length; f++) 
////		{
////			minmax[f][0] = Double.MAX_VALUE;
////			minmax[f][1] = Double.NEGATIVE_INFINITY;
////			
////		}
//		
//		for (Solution solution : population) {
//			solution.setAttribute(FITNESS_ATTRIBUTE, Double.NEGATIVE_INFINITY);
////			for (int f = 0; f < length; f++) 
////			{
////				if (solution.getObjective(f) < minmax[f][0])
////				{
////					minmax[f][0] = solution.getObjective(f);
////				}
////				if (solution.getObjective(f) > minmax[f][1])
////				{
////					minmax[f][1] = solution.getObjective(f);
////				}
////			}
//		}
//		
////		double[] checkd = new double[length];
////		for (int f = 0; f < length; f++) 
////		{
////			double temp = minmax[f][1] - minmax[f][0];
////			checkd[f] = temp/popsize;
////			
////		}
//		
//		Population uniqueFront = new Population();
//		
//		int count = 0;
//		int size = 0;
//		for (Solution s1 : population) {
//			boolean isDuplicate = false;
//
//			
//			for (Solution s2 : uniqueFront) {
//				double mindis = Math.abs(s1.getObjective(0)-s2.getObjective(0));  	
//				double maxdis = mindis;
//								
//				for (int f = 1; f < length; f++) 
//				{
//					double temp = Math.abs(s1.getObjective(f)-s2.getObjective(f)) ;
//					if (temp < mindis)
//					{
//						mindis = temp;
//					}else if (temp > maxdis)
//					{
//						maxdis = temp;
//					}
//				}
//				if ((maxdis == 0) || ((mindis/maxdis) < 1e-5)) 
//				{
//					isDuplicate = true;
//					break;
//				}				
//				
//				//method 2
////				for (int f = 0; f < length; f++) 
////				{
////					double temp = Math.abs(s1.getObjective(f)-s2.getObjective(f)) ;
////					if ((temp < checkd[f]/100) || (temp > checkd[f]*100))
////					{
////						isDuplicate = true;
////						break;
////					}
////				}
//				//end method 2
//			}
//			
//			if (!isDuplicate) {
//				size++;
//				uniqueFront.add(s1);
//				NoDup[count] = size;
//			}
//			count++;
//		}
//		
//		int[] record = new int[size];
//		count = 1;
//		int rn = 0;
//		for (int i = 0; i < popsize; i++) {
//			if (NoDup[i] == count)
//			{
//				record[rn] = i;
//				rn++;
//				count++;
//			}
//		}
//		
//		
//		if (uniqueFront.size() <= 2) {
//			for (Solution solution : population) {
//				solution.setAttribute(FITNESS_ATTRIBUTE, 0.0);
//			}
//			if (uniqueFront.size() <= 1) {
//				for (Solution solution : population) {
//					solution.setAttribute(FITNESS_ATTRIBUTE, 1.0);
//				}
//			}
//		} else {
//			
//			List<Solution> solutions = copy(uniqueFront);
//			int n = uniqueFront.size();
//			
//			double[][] Euclideandis= new double[n][n];
//			calculateEuDis(solutions, Euclideandis);
//			
//			double totalGI = calculateGI(n, n, Euclideandis);
//			
//			for (int i = 0; i < n; i++) {
//			
//				double gi = calculateGI(n, i, Euclideandis);
//				population.get(record[i]).setAttribute(FITNESS_ATTRIBUTE, totalGI - gi);
//			}
//		}
//		
//	}
	

	
	@Override
	public void evaluate(Population population) {
		
		if (population.size() <= 2) {
			for (Solution solution : population) {
				solution.setAttribute(FITNESS_ATTRIBUTE, 0.0);
			}
		} else {
			
			List<Solution> solutions = copy(population);
			int n = population.size();
			
			double[][] Euclideandis= new double[n][n];
			calculateEuDis(solutions, Euclideandis);
			
			double totalGI = calculateGI(n, n, Euclideandis);
			
			for (int i = 0; i < n; i++) {
			
				double gi = calculateGI(n, i, Euclideandis);
				population.get(i).setAttribute(FITNESS_ATTRIBUTE, totalGI - gi);
			}
		}
		
	}
	
	
	
	private void calculateEuDis(List<Solution> solutions, double[][] EuDis) {
		int n = solutions.size();
		int length = solutions.get(0).getNumberOfObjectives();
		double distance = 0;
		for (int i = 0; i < n-1; i++) {
			for (int j = i+1; j < n; j++) {
				distance = 0;  
	              
                for (int f = 0; f < length; f++) {  
                    double temp = Math.pow((solutions.get(i).getObjective(f)-solutions.get(j).getObjective(f)), 2);  
                    distance += temp;  
                }
                distance = Math.sqrt(distance);  
                EuDis[i][j] = distance;
                EuDis[j][i] = distance;
			}
		}
	}

	private double calculateGI(int n, int number, double[][] EuDis) {
		double givalue = 1;
		
		if (number == n)
		{
			for (int i = 0; i < n; i++) {
				double[] onesolution = new double[n-1];
				int j = 0;
				while (j < i)
				{
					onesolution[j] = EuDis[i][j];
					j++;
				}
				while (j < n-1)
				{
					onesolution[j] = EuDis[i][j+1];
					j++;
				}
				
				Arrays.sort(onesolution);
				givalue = givalue * onesolution[0];
			}
		}
		else
		{
			double[][] EuDis1 = new double[n-1][n-1];
			int jrow = 0;
			int jcolumn = 0;
			while (jrow < number)
			{
				jcolumn = 0;
				while (jcolumn < number)
				{
					EuDis1[jrow][jcolumn] = EuDis[jrow][jcolumn];
					jcolumn++;
				}
				while (jcolumn < n-1)
				{
					EuDis1[jrow][jcolumn] = EuDis[jrow][jcolumn+1];
					jcolumn++;
				}
				jrow++;
			}
				
			while (jrow < n-1)
			{
				jcolumn = 0;
				while (jcolumn < number)
				{
					EuDis1[jrow][jcolumn] = EuDis[jrow+1][jcolumn];
					jcolumn++;
				}
				while (jcolumn < n-1)
				{
					EuDis1[jrow][jcolumn] = EuDis[jrow+1][jcolumn+1];
					jcolumn++;
				}
				jrow++;
			}	
				


			for (int i = 0; i < n-1; i++) {
				double[] onesolution = new double[n-2];
				int j = 0;
				while (j < i)
				{
					onesolution[j] = EuDis1[i][j];
					j++;
				}
				while (j < n-2)
				{
					onesolution[j] = EuDis1[i][j+1];
					j++;
				}
				
				Arrays.sort(onesolution);
				givalue = givalue * onesolution[0];
			}
			
			
		}

		return givalue;
	}

	/**
	 * Returns a copy of the population.  The fast non-dominated sorting
	 * routine reorders solutions in the population, so creating a copy allows
	 * the original population to remain unchanged.  
	 * 
	 * @param population the original population
	 * @return a copy of the population
	 */
	private List<Solution> copy(Population population) {
		List<Solution> pool = new ArrayList<Solution>();
		
		for (Solution solution : population) {
			pool.add(solution);
		}
		
		return pool;
	}
	
	
	@Override
	public boolean areLargerValuesPreferred() {
		return true;
	}



}
